/// <reference types="react" />
import * as React from 'react';
import { TSteppableInputProps } from '../SteppableInput/SteppableInput';
import { ComponentClass } from 'react';
import { TControlProps } from '../Control/Control';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare type TDateValueProps = TControlProps<Date | null | undefined>;
export declare type TCalendarProps = TDateValueProps & {
    onMouseDown?: React.EventHandler<React.MouseEvent<Element>>;
    min?: Date;
    max?: Date;
};
export declare type TDateInputOwnProps = TSteppableInputProps & TDateValueProps & {
    min?: Date;
    max?: Date;
    calendarIcon?: React.ReactElement<any>;
    onClear?: Function;
    target?: Element;
    Calendar?: React.ComponentClass<TCalendarProps> | React.SFC<TCalendarProps>;
};
export declare type TDateDefaultProps = {
    SteppableInput: React.ComponentClass<TSteppableInputProps> | React.SFC<TSteppableInputProps>;
    ButtonIcon: React.ComponentClass<TButtonIconProps>;
};
export declare type TDateInputInjectedProps = {
    theme: {
        inner?: string;
        inner_isFilled?: string;
        section?: string;
        section_isActive?: string;
        separator?: string;
        SteppableInput?: TSteppableInputProps['theme'];
        ButtonIcon?: TButtonIconProps['theme'];
        CalendarButtonIcon?: TButtonIconProps['theme'];
    };
};
export declare type TDateInputFullProps = TDateInputOwnProps & TDateInputInjectedProps & TDateDefaultProps;
export declare const DATE_INPUT: symbol;
export declare type TDateInputProps = ObjectClean<PartialKeys<TDateInputFullProps, 'theme' | 'SteppableInput' | 'ButtonIcon'>>;
export declare const DateInput: ComponentClass<TDateInputProps>;
