"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var classnames = require("classnames");
var ExpandableHandler_1 = require("./ExpandableHandler");
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
exports.EXPANDABLE = Symbol('Expandable');
var RawExpandable = /** @class */ (function (_super) {
    tslib_1.__extends(RawExpandable, _super);
    function RawExpandable() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onHandlerClick = function () {
            var _a = _this.props, onValueChange = _a.onValueChange, value = _a.value;
            onValueChange && onValueChange(!value);
        };
        return _this;
    }
    RawExpandable.prototype.render = function () {
        var _a = this.props, theme = _a.theme, Handler = _a.Handler, value = _a.value, children = _a.children;
        var className = classnames(theme.container, (_b = {},
            _b[theme.container_isExpanded] = value,
            _b));
        return (React.createElement("div", { className: className },
            React.createElement("div", { className: theme.handler, onClick: this.onHandlerClick },
                React.createElement(Handler, { isExpanded: value, theme: theme.Handler })),
            React.createElement("div", { className: theme.content }, children)));
        var _b;
    };
    RawExpandable.defaultProps = {
        Handler: ExpandableHandler_1.ExpandableHandler,
    };
    RawExpandable = tslib_1.__decorate([
        pure_1.PURE
    ], RawExpandable);
    return RawExpandable;
}(React.Component));
exports.Expandable = withTheme_1.withTheme(exports.EXPANDABLE)(RawExpandable);
//# sourceMappingURL=Expandable.js.map