/// <reference types="react" />
import * as React from 'react';
import { ComponentClass } from 'react';
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { TInputProps } from '../input/Input';
export declare const STEPPABLE_INPUT: symbol;
export declare type TPickedInputProps = Pick<TInputProps, 'error' | 'onBlur' | 'onFocus' | 'onKeyDown' | 'onClick'>;
export declare type TFullSteppableInputProps = TPickedInputProps & {
    isDisabled?: TInputProps['isDisabled'];
    tabIndex?: number;
    onIncrement?: Function;
    onDecrement?: Function;
    onClear?: Function;
    incrementIcon?: React.ReactElement<any>;
    decrementIcon?: React.ReactElement<any>;
    clearIcon?: React.ReactElement<any>;
    children?: any;
    Input: React.ComponentClass<TInputProps> | React.SFC<TInputProps>;
    ButtonIcon: React.ComponentClass<TButtonIconProps> | React.SFC<TButtonIconProps>;
    theme: {
        inner?: string;
        Input?: TInputProps['theme'];
        ButtonIcon?: TButtonIconProps['theme'];
        ClearButtonIcon?: TButtonIconProps['theme'];
    };
};
export declare type TSteppableInputProps = ObjectClean<PartialKeys<TFullSteppableInputProps, 'theme' | 'Input' | 'ButtonIcon'>>;
export declare const SteppableInput: ComponentClass<TSteppableInputProps>;
export declare function checkParentsUpTo(node?: Element | null, checkNode?: Element, upToNode?: Element): boolean;
