/// <reference types="react" />
import * as React from 'react';
import { ObjectClean } from 'typelevel-ts/lib';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const TABLE: symbol;
export declare type TTableTheme = {
    container?: string;
    head?: string;
    body?: string;
    row?: string;
    cell?: string;
    cell_isInHead?: string;
};
export declare type TFullTableProps = {
    theme: TTableTheme;
    children?: React.ReactNode;
};
export declare type TFullTableHeadProps = TFullTableProps;
export declare type TFullTableBodyProps = TFullTableProps;
export declare type TFullTableRowProps = TFullTableProps & {
    onClick?: React.MouseEventHandler<HTMLTableRowElement>;
    onMouseOver?: React.MouseEventHandler<HTMLTableRowElement>;
    onMouseOut?: React.MouseEventHandler<HTMLTableRowElement>;
    row?: string;
    isInHead?: boolean;
};
export declare type TFullTableCellProps = TFullTableProps & {
    onClick?: React.MouseEventHandler<HTMLTableRowElement>;
    onMouseOver?: React.MouseEventHandler<HTMLTableRowElement>;
    onMouseOut?: React.MouseEventHandler<HTMLTableRowElement>;
    style?: React.CSSProperties;
    colSpan?: number;
    rowSpan?: number;
    isInHead?: boolean;
};
export default class RawTable extends React.Component<TFullTableProps> {
    render(): JSX.Element;
}
export declare class RawTableHead extends React.Component<TFullTableHeadProps> {
    render(): JSX.Element;
}
export declare type TTableProps = ObjectClean<PartialKeys<TFullTableProps, 'theme'>>;
export declare const Table: React.ComponentClass<TTableProps>;
export declare type TTableBodyProps = ObjectClean<PartialKeys<TFullTableBodyProps, 'theme'>>;
export declare const TableBody: React.ComponentClass<TTableBodyProps>;
export declare type TTableHeadProps = ObjectClean<PartialKeys<TFullTableHeadProps, 'theme'>>;
export declare const TableHead: React.ComponentClass<TTableHeadProps>;
export declare type TTableRowProps = ObjectClean<PartialKeys<TFullTableRowProps, 'theme'>>;
export declare const TableRow: React.ComponentClass<TTableRowProps>;
export declare type TTableCellProps = ObjectClean<PartialKeys<TFullTableCellProps, 'theme'>>;
export declare const TableCell: React.ComponentClass<TTableCellProps>;
