"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var BehaviorSubject_1 = require("rxjs/BehaviorSubject");
var animationFrame_1 = require("rxjs/scheduler/animationFrame");
require("rxjs/add/operator/subscribeOn");
// tslint:disable-next-line
var hoistNonReactStatics = require('hoist-non-react-statics');
function withRX(select) {
    return function (Target) {
        var WithRX = /** @class */ (function (_super) {
            tslib_1.__extends(WithRX, _super);
            function WithRX(props) {
                var _this = _super.call(this, props) || this;
                _this.props$ = new BehaviorSubject_1.BehaviorSubject(_this.props);
                _this.selectResult = select(_this.props$.asObservable());
                _this.input$ = _this.selectResult.props$;
                _this.effect$ = _this.selectResult.effects$;
                _this.inputSubscription = _this.input$
                    .subscribeOn(animationFrame_1.animationFrame)
                    .subscribe(function (state) { return _this.setState(state); });
                _this.effectSubscription = _this.effect$.subscribeOn(animationFrame_1.animationFrame).subscribe();
                return _this;
            }
            WithRX.prototype.componentWillReceiveProps = function (props) {
                this.props$.next(props);
            };
            WithRX.prototype.componentWillUnmount = function () {
                this.inputSubscription.unsubscribe();
                this.effectSubscription.unsubscribe();
            };
            WithRX.prototype.render = function () {
                return react_1.createElement(Target, Object.assign({}, this.props, this.state));
            };
            WithRX.displayName = "WithRX(" + (Target.displayName || Target.name) + ")";
            return WithRX;
        }(react_1.Component));
        hoistNonReactStatics(WithRX, Target);
        return WithRX;
    };
}
exports.withRX = withRX;
//# sourceMappingURL=with-rx.js.map